__doc__ = """ExtendedManagmentTabs mixin product module.
See README.txt for more details."""

__version__ = '0.0.5'


import Globals
from Globals import HTMLFile
#from Globals import MessageDialog
#from Globals import Persistent

#import OFS.SimpleItem
#import Acquisition
#import AccessControl.Role
from string import split
from App.Management import Tabs

from AccessControl import getSecurityManager

from Shared.Torped.FunctionTemplate import FunctionTemplate


def createManageIndex(manage_options=None,index=None,lpath=None):
    if index is None: index={}
    if lpath is None: lpath=[]
    try: options=tuple(manage_options)
    except: options=tuple(manage_options())        
    for option in options:
        if option.has_key('label') and option.has_key('action'):
            newlpath = lpath + [option['label']]
            if not index.has_key(option['action']): index[option['action']] = [tuple(newlpath)]
            else: index[option['action']] = index[option['action']] + [tuple(newlpath)]
            if option.has_key('submenu') and option['submenu'] is not None:
                index = createManageIndex(manage_options=option['submenu'],index=index,lpath=newlpath)
    return index        


class ExtendedManagmentTabs(Tabs): 
    """ExtendedManagmentTabs object."""
        

    manage_options = ()

    _v_manage_options_label_index = createManageIndex(manage_options=manage_options)

    ex_manage_tabs__roles__=('Anonymous',)
    ex_manage_tabs = HTMLFile('ex_manage_tabs', globals())
    
    ex_manage_tabs_finish__roles__=('Anonymous',)
    ex_manage_tabs_finish = HTMLFile('ex_manage_tabs_finish', globals())

    filtered_manage_options__roles__=None
    def filtered_manage_options(self, REQUEST=None, manage_options=None):
        if manage_options is None: manage_options = self.manage_options 
        validate=getSecurityManager().validate
        result=[]
        try: options=tuple(manage_options )
        except: options=tuple(manage_options())
        for d in options:
            filter=d.get('filter', None)
            if filter is not None and not filter(self):
                continue
            path=d.get('path', None)
            if path is None: path=d['action']
            o=self.unrestrictedTraverse(path, None)
            if o is None: continue
            try:
                if validate(container=self, value=o):
                    result.append(d)
            except:
                if not hasattr(o, '__roles__'):
                    result.append(d)
        return result

    manage_tabs__roles__=('Anonymous',)
    def manage_tabs(self,client,REQUEST=None):

        if REQUEST==None and client.has_key('REQUEST'):
            REQUEST = client['REQUEST']
        if client is None or REQUEST is None: raise "TabError"
        if client.has_key('management_views'): management_views = client['management_views']
        else: management_views = None
        
        manage_options = self.filtered_manage_options(manage_options=self.manage_options)
        result = ""
        supertab = ()
        method = split(REQUEST.URL,'/')[-1:][0]        
        level = 0
        help_option = None
        
        if self._v_manage_options_label_index.has_key(method): lpaths = self._v_manage_options_label_index[method]
        else: lpaths = None
        while manage_options is not None:
            n_ = len(manage_options)-1
            a_ = -1
            sequence_start = 1
            sequence_index = 0
            new_manage_options = None
            for option in manage_options:
              if option.has_key('action') and option.has_key('label'):
                if  method==option['action'] or (REQUEST.URL[-17:]=='/manage_workspace' and sequence_start and level==0):
                    a_ = sequence_index
                    if option.has_key('submenu') and option['submenu'] is not None: 
                        new_manage_options = self.filtered_manage_options(manage_options=option['submenu'])
                    supertab = supertab + (option['label'],)    
                    help_option = option
                    break
                elif client.has_key('management_view') and type(client['management_view'])==type(''):
                    if client['management_view'] == option['label']: 
                        a_ = sequence_index
                        if option.has_key('submenu') and option['submenu'] is not None: 
                            new_manage_options = self.filtered_manage_options(manage_options=option['submenu'])
                        supertab = supertab + (option['label'],)      
                        help_option = option
                        break
                elif client.has_key('management_view') and type(client['management_view'])==type(()):
                    if len(client['management_view']) > level and client['management_view'][level] == option['label']:
                        a_ = sequence_index
                        if option.has_key('submenu') and option['submenu'] is not None: 
                            new_manage_options = self.filtered_manage_options(manage_options=option['submenu'])
                        supertab = supertab + (option['label'],) 
                        if method==option['action']:
                            help_option = option
                        break
                elif lpaths is not None:
                    for lpath in lpaths:
                        if len(lpath) > level and lpath[level]==option['label']:
                            a_ = sequence_index
                            supertab = supertab + (option['label'],)      
                            if option.has_key('submenu') and option['submenu'] is not None: 
                                new_manage_options = self.filtered_manage_options(manage_options=option['submenu'])
                            if method==option['action']:
                                help_option = option
                            break
                sequence_start = 0
                sequence_index = sequence_index + 1
            if level==0: label = 'Zope'
            else: label = ''
            result = result + self.ex_manage_tabs(None,client,manage_options=manage_options,REQUEST=REQUEST,a_=a_,n_=n_,label=label)
            last_manage_options = manage_options
            manage_options = new_manage_options 
            level = level + 1
        result = result + self.ex_manage_tabs_finish(self,client,manage_options=last_manage_options,help_option=help_option,REQUEST=REQUEST,SCRIPT_NAME=client['SCRIPT_NAME'], PATH_INFO=client['PATH_INFO'])
        return result        

    manage_tabs = FunctionTemplate(manage_tabs)
        
Globals.default__class_init__(ExtendedManagmentTabs)
        